<template>
  <v-row class="py-4">
    <v-col
      class="d-flex"
      cols="12"
      sm="12"
      md="6"
    >
      <v-select
        :items="filmsList"
        label="Filter the character by movies"
        :value="selectedFilm"
        solo
        @input="setFilmFilter"
      ></v-select>
    </v-col>
  </v-row>
</template>

<script lang="ts">
import axios, {AxiosResponse} from 'axios';
import {FilmData, ResultData} from '~/types/types';
import {ref, useRoute, useRouter} from "@nuxtjs/composition-api";
import Vue from "vue";

interface BaseFilterItem {
  text: string,
  value: string | null
}

export default Vue.extend({
  name: "BaseFilter.vue",

  setup() {
    const filmsList = ref<BaseFilterItem[]>([]);
    const route = useRoute()
    const router = useRouter();
    const selectedFilm = ref<string | null>(null);

    const fetchFilmsData = async () => {
      const filmFilter = route.value?.query?.film as string;
      const response = await axios.get("https://swapi.dev/api/films/") as AxiosResponse<ResultData<FilmData>>;
      filmsList.value = [
        {
          text: "All",
          value: null
        },
        ...response.data.results.map(film => ({
          text: film.title,
          value: film.url
        }))
      ];
      selectedFilm.value = filmFilter ?? null;
    }

    fetchFilmsData()

    const setFilmFilter = (value: string) => {
      router.push({path: '/', query: value ? {film: value} : {}})
    }

    return {
      filmsList,
      selectedFilm,
      setFilmFilter
    }
  }
})
</script>

<style scoped>

</style>
